<?php
/**
* @package Joostina
* @copyright   (C) 2007 Joostina team.   .
* @license  http://www.gnu.org/copyleft/gpl.html GNU/GPL,  LICENSE.php
* Joostina! -   .     
*       GNU,  
*       , 
*     GNU    
*       .
*        ,   COPYRIGHT.php.
*/

//   
defined( '_VALID_MOS' ) or die( '   ' );

$pathLang	= $mosConfig_absolute_path . '/administrator/components/com_customquickicons/lang/';
$tmpLang	= $GLOBALS['mosConfig_lang'];

// tries to get adminlang (if defined -see MGFi www.mgfi.info)
if( isset( $GLOBALS['mosConfig_alang'] )){
    if( file_exists( $pathLang . $GLOBALS['mosConfig_alang'] . '.php' )) {
        $tmpLang = $GLOBALS['mosConfig_alang'];
    }
}
if( file_exists( $pathLang . $tmpLang . '.php' )) {
    include( $pathLang . $tmpLang . '.php' );
} else {
    @include( $pathLang . 'russian.php' );
}

// check lng.var (if com is not or uninstalled)
if( !defined( '_QI_MOD_NO_COM') ) {
	define( '_QI_MOD_NO_COM', ' com_customquickicons  ! ' );
}

// check if module is installed and published at correct position
$query = 'SELECT id, position'
. ' FROM #__modules'
. ' WHERE module = \'mod_customquickicons\''
;
$database->setQuery( $query );
$rows = $database->loadObjectList();

// check for existing component
if( !file_exists( $mosConfig_absolute_path . '/administrator/components/com_customquickicons/admin.customquickicons.php' ) || !$rows[0]->id ) {
	echo _QI_MOD_NO_COM;
}elseif( $rows[0]->position != 'icon' ) {
	echo _QI_ERR_MOD_INCORR_POS
	. '<br />'
	. '<a href="index2.php?option=com_modules&amp;client=admin" title="' . _QI_MOD_MGMNT . '">' . _QI_MOD_MGMNT . '</a>';
}else{
	if( !defined( '_QUICKICON_MODULE' )) {
	    /** ensure that functions are declared only once */
        define( '_QUICKICON_MODULE', 1 );

        function MOD_quickiconButton( $row, $newWindow ){
        	global $mosConfig_live_site;

            $title  = ( $row->akey ? $row->title . ' [ ' . _QI_MOD_ACCESSKEY . ' ' . $row->akey . ' ]' : ( $row->title ? $row->title : $row->text ));

            $accKey = $row->akey ? ' accesskey="' . $row->akey . '"' : ''; ?>
            <div style="float:left;">
                <div class="icon">
                    <a href="<?php echo htmlentities( $row->target ); ?>" title="<?php echo $title; ?>"<?php echo $accKey . $newWindow; ?>>
                        <?php
                        /* output
                         * 0    icon & text
                         * 1    text only
                         * 2    icon only
                         */
                        $icon = '<img src="' . $mosConfig_live_site . $row->icon . '" alt="" border="0" />';
                        if( $row->display == 1 ){ ?>
                            <span><?php echo $row->prefix . $row->text . $row->postfix; ?></span>
                            <?php
                        }elseif( $row->display == 2 ){
                            // echo mosAdminMenus::imageCheckAdmin( $row->icon, '/administrator/images/', NULL, NULL, $title );
                            echo $icon;
                        }else{
                            // echo mosAdminMenus::imageCheckAdmin( $row->icon, '/administrator/images/', NULL, NULL, $title);
                            echo $icon; ?>
                            <span><?php echo $row->prefix . $row->text . $row->postfix; ?></span>
                            <?php
                        } ?>
                    </a>
                </div>
            </div>
            <?php
        } ?>

        <div id="cpanel">
            <?php
            $query = 'SELECT *'
            . ' FROM #__custom_quickicons'
            . ' WHERE published = 1'
            . ' AND gid <= ' . $my->gid
            . ' ORDER BY ordering'
            ;
            $database->setQuery($query);
            $rows = $database->loadObjectList();
            if( $database->getErrorNum() ) {
                echo $database->stderr();
                return false;
            }

            foreach( $rows AS $row ){
                $callMenu = true;
                if( $row->cm_check ){
                    if( !file_exists( $mosConfig_absolute_path . '/administrator/components/' . $row->cm_path )){
                        $callMenu = false;
                    }
                }
                if( $callMenu ){
                    $newWindow = $row->new_window ? ' target="_blank"' : '';
                    MOD_quickiconButton( $row, $newWindow );
                }
            }

            $securitycheck 	= intval( $params->get( 'securitycheck', 1 ) );

            if( !empty( $securitycheck )) {
            // show security setting check
                josSecurityCheck('88%');
            } ?>
        </div>
        <?php
    }
}
?>